	Title	VSCyr
	Subttl	VerySoft EGA/VGA Cyrrilic Support

;NoEra	Equ	0		;No screen erase at startup
;LapTop	Equ	0		;Use different fonts for bold/non-bold attrs
;F8x19	Equ	0		;Enable 8x19 font

;+
; Copyright (c) 1993 Oleg Safiullin <form@pdp-11.org.ru>
;
; Permission to use, copy, modify, and distribute this software for any
; purpose with or without fee is hereby granted, provided that the above
; copyright notice and this permission notice appear in all copies.
;
; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
; WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
; MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
; ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
; WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
; ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
; OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;-

Code	Segment
	Org	100h
	Assume	cs: Code, ds: Code

SaveBX:	jmp	Rentry

Answer:	mov	ax, 'VS'
	iret

GetInf:	cmp	bh, 2
	jb	GoTo10
	cmp	bh, 7
	ja	GoTo10
	mov	cs: word ptr [SaveBX], bx
	call	Call10
	push	bx
	mov	bl, cs: byte ptr [SaveBX+1]
	xor	bh, bh
	dec	bx
	dec	bx
	shl	bx, 1
	push	cs
	pop	es
	mov	bp, cs: [bx].FOffst
	pop	bx
	iret

SetFnt:	cmp	al, 30h
	jz	GetInf
	cmp	al, 00h
	jz	GoTo10
	cmp	al, 03h
	jz	GoTo10
	cmp	al, 10h
	jz	GoTo10
	cmp	al, 20h
	jz	GoTo10
	cmp	al, 21h
	jz	GoTo10
	call	Call10
	jmp	short FReset

Intr10:	cmp	ah, 99h
	jz	Answer
	or	ah, ah
	jz	SetMod
	cmp	ah, 11h
	jz	SetFnt
GoTo10:	db	0EAh
Orig10	dd	0

SetMod:	call	Call10
FReset:	push	ax
	push	bx
	push	cx
	push	dx
	push	bp
	push	es
	mov	ax, 1130h
	xor	bx, bx
	call	Call10
	mov	bp, offset Font08
ifdef	LapTop
	mov	dx, offset Font08d
endif
	cmp	cl, 8
	jz	LoadIt
	mov	bp, offset Font14
ifdef	LapTop
	mov	dx, offset Font14d
endif
	cmp	cl, 14
	jz	LoadIt
	mov	bp, offset Font16
ifdef	LapTop
	mov	dx, offset Font16d
endif
	cmp	cl, 16
	jz	LoadIt
ifdef	F8x19
	mov	bp, offset Font19
ifdef	LapTop
	mov	dx, offset Font19d
endif
	cmp	cl, 19
	jz	LoadIt
endif
IntExt:	pop	es
	pop	bp
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	iret

LoadIt:	push	bx
	push	cx
	xor	bx, bx
	mov	ah, 3
	push	dx
	call	Call10
	pop	dx
	or	cx, cx
	pop	cx
	pop	bx
	jnz	TextXX
GrafXX:	mov	ax, 1121h
	call	Call10
	jmp	short IntExt

TextXX:
ifdef	LapTop
	push	dx
endif
	xor	dx, dx
	xchg	bh, cl
	mov	cx, 256
	mov	ax, 1100h
	call	Call10
ifdef	LapTop
	pop	bp
	mov	ax, 1100h
	inc	bl
	call	Call10
endif
	mov	ax, 1103h
ifdef	LapTop
	mov	bl, 4
else
	xor	bx, bx
endif
	call	Call10
	jmp	IntExt

FOffst	dw	Font14, Font08, Font08, Font14, Font16, Font16

Call10:	pushf
	call	cs: dword ptr [Orig10]
	ret

Font08	Label	byte
	Include	vsf8x8.inc

ifdef	Laptop
Font08d	Label	byte
	Include	vsf8x8d.inc
endif

Font14	Label	byte
	Include	vsf8x14.inc

ifdef	LapTop
Font14d	Label	byte
	Include	vsf8x14d.inc
endif

Font16	Label	byte
	Include	vsf8x16.inc

ifdef	LapTop
Font16d	Label	byte
	Include	vsf8x16d.inc
endif

ifdef	F8x19
Font19	Label	byte
	Include	vsf8x19.inc

ifdef	LapTop
Font19d	Label	byte
	Include	vsf8x19d.inc
endif
endif

Rentry:	mov	ah, 99h
	int	10h
	cmp	ax, 'VS'
	jnz	Instal
	mov	dx, offset AlrInst
PRExit:	mov	ah, 9
	int	21h
	ret
Instal:	mov	ax, 1A00h
	int	10h
	cmp	al, 1Ah
	jz	OKInst
	mov	ah, 12h
	mov	bl, 10h
	int	10h
	cmp	bl, 10h
	jnz	OKInst
	mov	dx, offset NoDispl
	jmp	short PRExit
OKInst:	mov	ax, 3510h
	int	21h
	mov	word ptr [Orig10], bx
	mov	word ptr [Orig10+2], es
	mov	ax, 2510h
	mov	dx, offset Intr10
	int	21h
	mov	ax, 251Fh
	mov	dx, offset Font08 + 1024
	int	21h
	mov	ah, 0Fh
	int	10h
	xor	ah, ah
ifdef	NoEra
	or	al, 80h
endif
	int	10h
	mov	ah, 9
	mov	dx, offset Install
	int	21h
ifdef	NoEra
	xor	ax, ax
	mov	es, ax
	and	es:  byte ptr [487h], 7Fh
endif
	mov	dx, offset Rentry
	int	27h

Install	db	13, 10, 'VerySoft Cyrrilic 1.0 installed.'
	db	13, 10, 'Copyright (c) 1993 by VerySoft', 13, 10, '$'
AlrInst	db	13, 10, 'VerySoft Cyrrilic already installed', 13, 10, '$'
NoDispl	db	13, 10, 'No EGA/VGA adaptor found', 13, 10, '$'

Code	Ends
	End	SaveBX
